VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "SVGDoc"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Const DOCTYPE = "<!DOCTYPE svg PUBLIC ""-//W3C//DTD SVG 20010719//EN"" ""http://www.w3.org/TR/2001/PR-SVG-20010719/DTD/svg10.dtd"">"
Dim strDOCTYPE  As String
Const VERSION = "<?xml version=""1.0"" encoding=""iso-8859-1""?>"
Const CR = "<!-- Copyright 2001 by Helma Spona, erzeugt mit VBA-SVGKonverter Version 1.1 -->"
'Const SVGROOT = "<svg></svg>"

Private PropSRC As String
Private svgElements As Collection

Public Sub setDoctype(strDTD As String)
    Dim NodeT As SVGNode
    strDOCTYPE = strDTD
    Set NodeT = svgElements.Item(2)
    NodeT.NString = strDOCTYPE
    Set NodeT = Nothing
End Sub

Private Sub Class_Initialize()
    'Debug.Print "INIT SVGDoc " & Now()
    strDOCTYPE = DOCTYPE
    Set svgElements = New Collection
    PropSRC = ""
End Sub

Private Sub Class_Terminate()
    'Debug.Print "TERM SVGDoc " & Now()
    Set svgElements = Nothing
End Sub

Public Function createSVGDocument() As Collection
    Dim NodeT As SVGNode
    Set NodeT = New SVGNode
    NodeT.NString = VERSION
    NodeT.NType = svgVersion
    svgElements.Add NodeT
    
    Set NodeT = New SVGNode
    NodeT.NString = strDOCTYPE
    NodeT.NType = svgDoctype
    svgElements.Add NodeT

    Set NodeT = New SVGNode
    NodeT.NString = "<svg>"
    NodeT.NName = "svg"
    NodeT.NType = svgnodeBegin
    svgElements.Add NodeT

    Set NodeT = New SVGNode
    NodeT.NString = "</svg>"
    NodeT.NName = "svg"
    NodeT.NType = svgnodeend
    svgElements.Add NodeT
    
    Set NodeT = New SVGNode
    NodeT.NString = CR
    NodeT.NType = svgignore
    svgElements.Add NodeT

    Set createSVGDocument = svgElements
End Function

Public Function createNode(strNodeName As String, strNodeType As NodeTypes, Optional strNodeValue) As SVGNode
    Dim NodeT As New SVGNode
    Dim strTemp As String
    If Not IsMissing(strNodeValue) Then
        NodeT.NValue = strNodeValue
    End If
    NodeT.NName = strNodeName
    NodeT.NType = strNodeType

    If (strNodeType = svgnodefull) And (NodeT.NValue = "") Then
        strTemp = "<" & strNodeName & "/>"
    ElseIf (strNodeType = svgnodefull) And (NodeT.NValue <> "") Then
        strTemp = "<" & strNodeName & ">" & strNodeValue & "</" & strNodeName & ">"
    ElseIf strNodeType = svgnodeBegin Then
        strTemp = "<" & strNodeName & ">"
    ElseIf strNodeType = svgnodeend Then
        strTemp = "</" & strNodeName & ">"
    ElseIf strNodeType = svgcomment Then
        strTemp = "<!--" & strNodeName & "-->"
    End If
    NodeT.NString = strTemp
    Set createNode = NodeT
End Function



Public Function appendNode(objNode As SVGNode, Optional lngPosition, Optional NbeforeNode) As Long 'SVGNode
    Dim NodeT As SVGNode
    Dim NodeTemp As SVGNode
    Dim lngI As Long
    If IsMissing(lngPosition) And IsMissing(NbeforeNode) Then
        'Beide Parameter fehlen -> Am Ende Anfgen for </svg>
        lngI = svgElements.Count - 2
    ElseIf IsMissing(NbeforeNode) Then
        'An der gewnschten Position einfgen
        lngI = lngPosition
    ElseIf IsMissing(lngPosition) Then
        'Vor dem gewnschten Element einfgen
        Set NodeTemp = NbeforeNode
        lngI = -1
        For Each NodeT In svgElements
            lngI = lngI + 1
            If NodeT Is NodeTemp Then
                Exit For
            End If
        Next NodeT
        
        'svgElements.Add objNode, lngI
        If lngI = -1 Then lngI = svgElements.Count - 1
    End If
    If objNode.NId <> "" Then
        svgElements.Add Item:=objNode, Key:=objNode.NId, Before:=lngI + 1
    Else
        svgElements.Add Item:=objNode, Before:=lngI + 1
    End If
    'Set appendNode = svgElements(lngI + 1)
    appendNode = lngI + 1
End Function

Public Function getIndex(objNode As SVGNode) As Long
    Dim NodeT As SVGNode
    'Dim NodeTemp As SVGNode
    Dim lngI As Long
    Dim boolGefunden As Boolean
    'Set NodeTemp = objNode
    boolGefunden = False
    'Set NodeTemp = NbeforeNode
    lngI = 0
    For Each NodeT In svgElements
        'lngI = lngI + 1
        If NodeT Is objNode Then
            boolGefunden = True
            Exit For
        End If
        lngI = lngI + 1
    Next NodeT
    If boolGefunden = True Then
        lngI = lngI + 1
    Else
        lngI = -1
    End If
    getIndex = lngI
End Function


Public Function getCode() As String
    Dim NodeT As SVGNode
    For Each NodeT In svgElements
        getCode = getCode & NodeT.NString
        If (NodeT.NType <> svgnodeText) Then
            getCode = getCode & vbCrLf
        End If
    Next NodeT
End Function

Public Property Get Count() As Variant
    Count = svgElements.Count
End Property

Public Property Get SVGDoc() As SVGDoc
    Set SVGDoc = Me
End Property

Public Function getElementByIndex(lngIndex As Long) As SVGNode
    Set getElementByIndex = svgElements.Item(lngIndex)
End Function

Public Function getRootElement() As SVGNode
    Dim objNode As SVGNode
    'Set getRootElement = svgElements.Item(lngIndex)
    'Dim lngI As Long
    For Each objNode In svgElements
        If objNode.NName = "svg" Then
            Set getRootElement = objNode
            Exit Function
        End If
    Next objNode
    Set getRootElement = Nothing
End Function

Public Property Get SRC() As String
    SRC = PropSRC
End Property

Public Property Let SRC(ByVal vNewValue As String)
    PropSRC = vNewValue
End Property

Public Function saveAs(strSRC As String) As String
    PropSRC = strSRC
    saveAs = save()
End Function

Public Function save() As String
    Dim objFSO As New FileSystemObject
    Dim strVerz As String
    Dim strName As String
    Dim strExt As String
    Dim objTextFile As TextStream
    If PropSRC = "" Then
        save = "Kein Dateiname angegeben, keine Speicherung mglich!"
        Exit Function
    End If
    strVerz = objFSO.GetParentFolderName(PropSRC)
    If strVerz = "" Then
        strVerz = CurDir()
        PropSRC = objFSO.BuildPath(strVerz, PropSRC)
    End If
    strName = objFSO.GetFileName(PropSRC)
    strExt = objFSO.GetExtensionName(PropSRC)
    'Debug.Print strName & " "; strExt
    If strExt <> "svg" Then
        strName = strName & ".svg"
        PropSRC = objFSO.BuildPath(strVerz, strName)
    End If
    If objFSO.FolderExists(strVerz) = False Then
        'Verzeichnis erzeugen
        On Error GoTo FEHLER
        objFSO.CreateFolder (strVerz)
        On Error GoTo 0
    End If
    On Error GoTo FEHLER
    Set objTextFile = objFSO.CreateTextFile(PropSRC, True, False)
    objTextFile.Write getCode()
    On Error GoTo 0
    save = ""
    Set objFSO = Nothing
    Set objTextFile = Nothing
    
    Exit Function
FEHLER:
    save = Err.Description
    Exit Function
End Function
