VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "SVGNode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private SVGElem As NodeElem

Public Enum NodeTypes
    svgrootElem = 1
    svgnodeBegin = 2
    svgnodeend = 3
    svgnodefull = 4
    svgnodeText = 5
    svgDoctype = 6
    svgVersion = 7
    svgcomment = 8
    svgignore = 9
End Enum

Private Type NodeElem
    NodeType As NodeTypes
    NodeValue As String
    NodeId As String
    NodeIndex As Long
    NodeName As String
    NodeString As String
    NodeAttributes As String
End Type

Private Sub Class_Initialize()
    'Debug.Print "INIT SVGNode " & Now()
    SVGElem.NodeId = ""
    SVGElem.NodeIndex = -1
    SVGElem.NodeName = ""
    SVGElem.NodeString = ""
    SVGElem.NodeType = svgnodefull
    SVGElem.NodeValue = ""
    SVGElem.NodeAttributes = ""
End Sub

Public Function getPolygonData(varPosarray As Variant) As String
    Dim strPoints As String
    Dim lngI As Long
    For lngI = LBound(varPosarray) To UBound(varPosarray)
        varPosarray(lngI) = Round(varPosarray(lngI))
        If lngI Mod 2 = 0 Then
            strPoints = strPoints & varPosarray(lngI) & ","
        Else
            strPoints = strPoints & varPosarray(lngI) & " "
        End If
    Next lngI
    getPolygonData = strPoints
End Function

Private Sub Class_Terminate()
    'Debug.Print "TERM SVGNode " & Now()
End Sub

Public Property Get NString() As String
    NString = SVGElem.NodeString
End Property

Public Property Let NString(ByVal vNewValue As String)
    SVGElem.NodeString = vNewValue
End Property

Public Property Get NName() As String
    NName = SVGElem.NodeName
End Property

Public Property Let NName(ByVal vNewValue As String)
    SVGElem.NodeName = vNewValue
    setAttributes SVGElem.NodeAttributes
End Property

Public Property Get NIndex() As Long
    NIndex = SVGElem.NodeIndex
End Property

Public Property Let NIndex(ByVal vNewValue As Long)
    SVGElem.NodeIndex = vNewValue
End Property


Public Property Get NId() As String
    NId = SVGElem.NodeId
End Property

'Public Property Let NId(ByVal vNewValue As String)
'    SVGElem.NodeId = vNewValue
'End Property

Public Property Get NValue() As String
    NValue = SVGElem.NodeValue
End Property

Public Property Let NValue(ByVal vNewValue As String)
    SVGElem.NodeValue = vNewValue
End Property

Public Property Get NType() As NodeTypes
    NType = SVGElem.NodeType
End Property

Public Property Let NType(ByVal vNewValue As NodeTypes)
    SVGElem.NodeType = vNewValue
    setAttributes SVGElem.NodeAttributes
End Property

Private Property Get NAttributes() As String
    NAttributes = SVGElem.NodeAttributes
End Property

Private Property Let NAttributes(ByVal vNewValue As String)
    Dim strTemp As String
    SVGElem.NodeAttributes = vNewValue
    If vNewValue <> "" Then vNewValue = " " & vNewValue
    'NodeString berechnen
    If (SVGElem.NodeType = svgnodeBegin) Or (SVGElem.NodeType = svgrootElem) Then
        strTemp = "<" & SVGElem.NodeName & vNewValue & ">"
    ElseIf SVGElem.NodeType = svgnodeend Then
        strTemp = "</" & SVGElem.NodeName & vNewValue & ">"
    ElseIf (SVGElem.NodeType = svgnodefull) And (SVGElem.NodeValue = "") Then
        strTemp = "<" & SVGElem.NodeName & vNewValue & "/>"
    ElseIf (SVGElem.NodeType = svgnodefull) And (SVGElem.NodeValue <> "") Then
        strTemp = "<" & SVGElem.NodeName & vNewValue & ">" & SVGElem.NodeValue & "</" & SVGElem.NodeName & ">"
    ElseIf SVGElem.NodeType = svgcomment Then
        strTemp = "<!-- " & SVGElem.NodeName & vNewValue & " -->"
    Else
        strTemp = SVGElem.NodeString
    End If
    SVGElem.NodeString = strTemp
End Property

Public Sub setAttributes(strAttributes As String)
    Dim lngPos1 As Long, lngPos2 As Long
    Dim strId As String
    strAttributes = Replace(strAttributes, "'", """")
    SVGElem.NodeAttributes = strAttributes
    
    lngPos1 = InStr(1, strAttributes, "id=")
    If lngPos1 > 0 Then
        'Id setzen
        lngPos1 = InStr(lngPos1, strAttributes, """")
        lngPos2 = InStr(lngPos1 + 1, strAttributes, """")
        strId = Mid(strAttributes, lngPos1, lngPos2 - lngPos1)
    Else
        strId = ""
    End If
    SVGElem.NodeId = strId
    NAttributes = strAttributes
End Sub

Public Sub setAttribute(strAttributeName As String, strWert As String)
    Dim strAttrAlt As String
    Dim strAttrNeu As String
    Dim strAttributes() As String
    Dim lngI As Long
    Dim lngPos As Long
    Dim boolGefunden As Boolean
    strAttrAlt = SVGElem.NodeAttributes
    boolGefunden = False
    If strAttrAlt <> "" Then
        strAttributes = VBA.Split(strAttrAlt, " ")
        For lngI = LBound(strAttributes) To UBound(strAttributes)
            lngPos = InStr(1, strAttributes(lngI), strAttributeName & "=")
            If lngPos > 0 Then
                'Attribut vorhanden, -> ndern
                If strWert = "" Then
                    strAttributes(lngI) = ""
                Else
                    strAttributes(lngI) = strAttributeName & "=""" & strWert & """"
                End If
                boolGefunden = True
            End If
        Next lngI
        strAttrNeu = Join(strAttributes, " ")
        If boolGefunden = False Then
            strAttrNeu = strAttrNeu & " " & strAttributeName & "=""" & strWert & """"
        End If
        NAttributes = strAttrNeu
    Else
        NAttributes = strAttributeName & "=""" & strWert & """"
    End If
End Sub

Public Function getAttribute(strAttributeName As String) As String
    Dim strAttr As String
    Dim lngPos1 As Long, lngPos2 As Long
    strAttr = " " & SVGElem.NodeAttributes
    lngPos1 = InStr(1, strAttr, " " & strAttributeName & "=")
    If lngPos1 <= 0 Then
        getAttribute = ""
        Exit Function
    Else
        lngPos1 = lngPos1 + Len(" " & strAttributeName & "=") + 1
        lngPos2 = InStr(lngPos1, strAttr, """")
        If lngPos1 = lngPos2 Then
            getAttribute = ""
        Else
            getAttribute = Mid(strAttr, lngPos1, lngPos2 - lngPos1)
        End If
    End If
End Function

Public Function hasAttribute(strAttributeName As String) As Boolean
    Dim strAttr As String
    Dim lngPos1 As Long, lngPos2 As Long
    strAttr = " " & SVGElem.NodeAttributes
    lngPos1 = InStr(1, strAttr, " " & strAttributeName & "=")
    If lngPos1 > 0 Then
        hasAttribute = True
    Else
        hasAttribute = False
    End If
End Function

